Index: trunk/LMDZ.TITAN/libf/muphytitan/argparse.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/argparse.F90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/muphytitan/argparse.F90	(revision 3083)
@@ -1,39 +1,27 @@
-! Copyright Jérémie Burgalat (2010-2015,2017)
-! 
-! jeremie.burgalat@univ-reims.fr
-! 
-! This software is a computer program whose purpose is to provide configuration 
-! file and command line arguments parsing features to Fortran programs.
-! 
-! This software is governed by the CeCILL-B license under French law and
-! abiding by the rules of distribution of free software.  You can  use, 
-! modify and/ or redistribute the software under the terms of the CeCILL-B
-! license as circulated by CEA, CNRS and INRIA at the following URL
-! "http://www.cecill.info". 
-! 
-! As a counterpart to the access to the source code and  rights to copy,
-! modify and redistribute granted by the license, users are provided only
-! with a limited warranty  and the software's author,  the holder of the
-! economic rights,  and the successive licensors  have only  limited
-! liability. 
-! 
-! In this respect, the user's attention is drawn to the risks associated
-! with loading,  using,  modifying and/or developing or reproducing the
-! software by the user in light of its specific status of free software,
-! that may mean  that it is complicated to manipulate,  and  that  also
-! therefore means  that it is reserved for developers  and  experienced
-! professionals having in-depth computer knowledge. Users are therefore
-! encouraged to load and test the software's suitability as regards their
-! requirements in conditions enabling the security of their systems and/or 
-! data to be ensured and,  more generally, to use and operate it in the 
-! same conditions as regards security. 
-! 
-! The fact that you are presently reading this means that you have had
-! knowledge of the CeCILL-B license and that you accept its terms.
+! Copyright (c) (2013-2015,2017) Jeremie Burgalat (jeremie.burgalat@univ-reims.fr).
+!
+! This file is part of SWIFT
+!
+! Permission is hereby granted, free of charge, to any person obtaining a copy of
+! this software and associated documentation files (the "Software"), to deal in
+! the Software without restriction, including without limitation the rights to
+! use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
+! the Software, and to permit persons to whom the Software is furnished to do so,
+! subject to the following conditions:
+!
+! The above copyright notice and this permission notice shall be included in all
+! copies or substantial portions of the Software.
+!
+! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
+! FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
+! COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
+! IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
+! CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 
 !! file: argparse.F90
 !! summary: Command-line parser source file.
 !! author: J. Burgalat
-!! date: 2013-2015,2017
+!! date: 2013-2015,2017,2022
 
 #include "defined.h"
@@ -45,5 +33,5 @@
   !! For your own sanity, private methods that call Ancient Gods powers through
   !! evil black magic rituals are not described here.
-  !! 
+  !!
   !! If you only wish to have an overview of argparse usage, you'd better go
   !! [here](|url|/page/swift/p01_argparse.html).
@@ -52,5 +40,5 @@
   USE ERRORS
   USE FSYSTEM, ONLY : fs_termsize
-  USE STRING_OP, getpar => format_paragraph, splitstr  => format_string  
+  USE STRING_OP, getpar => format_paragraph, splitstr  => format_string
   IMPLICIT NONE
 
@@ -68,5 +56,5 @@
             argparser_add_option,       &
             argparser_add_positionals,  &
-            argparser_throw_error,      & 
+            argparser_throw_error,      &
             argparser_parse,            &
             argparser_help,             &
@@ -85,5 +73,5 @@
   ! ===========================
 
-  INTEGER, PARAMETER, PUBLIC :: ap_string  = st_string 
+  INTEGER, PARAMETER, PUBLIC :: ap_string  = st_string
     !! String value type identifier.
   INTEGER, PARAMETER, PUBLIC :: ap_complex = st_complex
@@ -98,30 +86,33 @@
   !> List of all available actions
 
-  INTEGER, PARAMETER, PUBLIC :: ap_store  = 1 
+  INTEGER, PARAMETER, PUBLIC :: ap_store   = 1
     !! store action ID : Each time the option is seen, values are replaced.
-  INTEGER, PARAMETER, PUBLIC :: ap_append = 2 
-    !! append action ID : Each time the option is seen, values are appended. 
-  INTEGER, PARAMETER, PUBLIC :: ap_count  = 3 
+  INTEGER, PARAMETER, PUBLIC :: ap_append  = 2
+    !! append action ID : Each time the option is seen, values are appended.
+  INTEGER, PARAMETER, PUBLIC :: ap_count   = 3
     !! count action ID : increase a counter each time the option is seen.
-  INTEGER, PARAMETER, PUBLIC :: ap_help   = 4 
+  INTEGER, PARAMETER, PUBLIC :: ap_help    = 4
     !! help action ID : help is requested !
+  INTEGER, PARAMETER, PUBLIC :: ap_version = 5
+    !! version action ID : version is requested !
 
   !> List of all available actions
-  INTEGER, DIMENSION(4), PARAMETER, PRIVATE :: ap_actions = (/ap_store,  &
+  INTEGER, DIMENSION(5), PARAMETER, PRIVATE :: ap_actions = (/ap_store,  &
                                                               ap_append, &
                                                               ap_count,  &
-                                                              ap_help/)
+                                                              ap_help,   &
+                                                              ap_version/)
   !> List of all recognized types by the parser
-  INTEGER, DIMENSION(5), PARAMETER, PRIVATE :: ap_types = (/ap_string,  & 
+  INTEGER, DIMENSION(5), PARAMETER, PRIVATE :: ap_types = (/ap_string,  &
                                                             ap_logical, &
                                                             ap_complex, &
                                                             ap_integer, &
-                                                            ap_real/) 
+                                                            ap_real/)
   !> The unknown flag
   !!
-  !! This flag is only intended to initialize flags. It is set by default during initialization 
+  !! This flag is only intended to initialize flags. It is set by default during initialization
   !! and quielty replaced by default flags, if user does not provide the relevant feature.
   INTEGER, PARAMETER :: ap_undef = -1
-    
+
   !> Add an option to the parser
   !!
@@ -131,11 +122,11 @@
   !! ```
   !!
-  !! The function defines a new argument based on input parameters, checks it and finally sets it 
-  !! in the parser. 
-  !! 
+  !! The function defines a new argument based on input parameters, checks it and finally sets it
+  !! in the parser.
+  !!
   !! In its first version both short (`sflag`) and long (`lflag`) options flags are mandatory. In its second
   !! form, a single flag (`flag`) is expected: the method will automatically deduce if it belongs to short or
   !! a long option flag based on the number of hyphens given.
-  !! 
+  !!
   !! `type` value should be one of the following module constants (which are aliases from [[string_op(module)]]):
   !!
@@ -145,5 +136,5 @@
   !! - `ap_integer` ([[string_op(module):st_integer(variable)]])
   !! - `ap_real` ([[string_op(module):st_real(variable)]])
-  !! 
+  !!
   !! `action` value should be one of the following module constants:
   !!
@@ -162,5 +153,5 @@
   !!  "X"  | Exactly X values. Where X is the string representation of an integer (0 is accepted).
   !!
-  !! On success, `noerror` is returned. Otherwise -9 error code is returned. Errors are only 
+  !! On success, `noerror` is returned. Otherwise -9 error code is returned. Errors are only
   !! produced by misuse of the function arguments. In such case, the program should be
   !! stopped: note that such error should not occur in _released_ programs.
@@ -168,9 +159,9 @@
     MODULE PROCEDURE ap_add_option_1, ap_add_option_2
   END INTERFACE
-  
+
   !> Get positional argument value(s)
   INTERFACE argparser_get_positional
     MODULE PROCEDURE ap_get_positional_sc, ap_get_positional_ve
-  END INTERFACE 
+  END INTERFACE
 
   !> Get optional argument value(s)
@@ -179,13 +170,13 @@
   !! FUNCTION argparser_get_value(this,name,output) RESULT(err)
   !! ```
-  !! 
+  !!
   !! This is the generic method that can be used to retrieve any kind of argument value(s) from the parser for a given
   !! argument name (as defined by the `dest` argument of [[argparse(module):argparser_add_option(interface)]].
   !! All the methods have the same dummy arguments only `output` dummy argument differs in type and shape.
-  !! 
+  !!
   !! @note
   !! For string vector, `output` is expected to be an allocatable vector of **assumed length**
   !! strings (thus string length is left to user responsability).
-  !! A good compromise for strings length is to use the [[string_op(module):st_slen(variable)]] 
+  !! A good compromise for strings length is to use the [[string_op(module):st_slen(variable)]]
   !! parameter.
   INTERFACE argparser_get_value
@@ -197,7 +188,7 @@
   !> Interface to [[argparse(module):argc(type)]] getters
   !!
-  !! All the functions have the same prototype, only kind and type of arguments changed 
+  !! All the functions have the same prototype, only kind and type of arguments changed
   !! from a function to the other.
-  INTERFACE argc_get_value                    
+  INTERFACE argc_get_value
     MODULE PROCEDURE ac_get_dv_sc, ac_get_rv_sc, ac_get_iv_sc, ac_get_lv_sc, &
                      ac_get_cv_sc, ac_get_sv_sc, ac_get_dv_ve, ac_get_rv_ve, &
@@ -230,9 +221,9 @@
     !! Defines a command-line argument.
     !!
-    !! An [[argparse(module):argc(type)]] object stores all information about a command-line 
+    !! An [[argparse(module):argc(type)]] object stores all information about a command-line
     !! argument, that is:
     !!
     !! - its name
-    !! - its optional flags 
+    !! - its optional flags
     !! - its type
     !! - its action
@@ -253,10 +244,10 @@
     TYPE(words)      :: meta
       !! Meta variable name(s) of the argument
-#if HAVE_FTNDTSTR 
+#if HAVE_FTNDTSTR
     CHARACTER(len=:), ALLOCATABLE :: default
-      !! Default flag 
+      !! Default flag
     CHARACTER(len=:), ALLOCATABLE :: name
       !! Name of the argument (needed to check and retrieve its value(s))
-    CHARACTER(len=:), ALLOCATABLE :: lflag 
+    CHARACTER(len=:), ALLOCATABLE :: lflag
       !! Long flag option (st_short_len max chars !)
     CHARACTER(len=:), ALLOCATABLE :: help
@@ -264,5 +255,5 @@
 #else
     CHARACTER(len=st_slen) :: default = ""
-      !! Default flag 
+      !! Default flag
     CHARACTER(len=st_slen) :: name
       !! Name of the argument (needed to check and retrieve its value(s))
@@ -278,5 +269,5 @@
     !! Command-line parser
     !!
-    !! This is the main object of the module. It stores definitions of CLI arguments and 
+    !! This is the main object of the module. It stores definitions of CLI arguments and
     !! their value(s) once the command-line have been parsed.
     TYPE(argc), PRIVATE, ALLOCATABLE, DIMENSION(:) :: args
@@ -298,24 +289,28 @@
 #if HAVE_FTNDTSTR
     CHARACTER(len=:), PRIVATE, ALLOCATABLE :: usg
-      !! Program command usage 
+      !! Program command usage
     CHARACTER(len=:), PRIVATE, ALLOCATABLE :: descr
       !! Program help description
-    CHARACTER(len=:), PRIVATE, ALLOCATABLE :: eplg 
+    CHARACTER(len=:), PRIVATE, ALLOCATABLE :: eplg
       !! Program help epilog
+    CHARACTER(len=:), PRIVATE, ALLOCATABLE :: vers
+      !! Application version string
 #else
     CHARACTER(len=st_llen), PRIVATE :: usg
-      !! Program command usage 
+      !! Program command usage
     CHARACTER(len=st_llen), PRIVATE :: descr
       !! Program help description
-    CHARACTER(len=st_llen), PRIVATE :: eplg 
+    CHARACTER(len=st_llen), PRIVATE :: eplg
       !! Program help epilog
+    CHARACTER(len=st_llen), PRIVATE :: vers
+      !! Application version string
 #endif
-    INTEGER, PRIVATE :: mxhlpos = 20 
+    INTEGER, PRIVATE :: mxhlpos = 20
       !! Position of the short help for options
     INTEGER, PRIVATE :: width = 0
-      !! Maximum width of the help 
+      !! Maximum width of the help
     LOGICAL, PRIVATE :: init = .false.
       !! Initialization control flag
-#if HAVE_FTNPROC    
+#if HAVE_FTNPROC
 
     CONTAINS
@@ -341,6 +336,8 @@
     PROCEDURE, PUBLIC  :: parse              => argparser_parse
       !! Parse the command-line (or the given input string).
-    PROCEDURE, PUBLIC  :: help               => argparser_help  
+    PROCEDURE, PUBLIC  :: help               => argparser_help
       !! Compute and print help
+    PROCEDURE, PUBLIC  :: version            => argparser_version
+      !! print version string
     PROCEDURE, PUBLIC  :: found              => argparser_found
       !! Check if an optional argument has been found on the command-line
@@ -356,5 +353,5 @@
     GENERIC, PUBLIC    :: add_option         => ap_add_option_1, &
                                                 ap_add_option_2
-    !> Get the values of the positionals stored in the parser.                                                
+    !> Get the values of the positionals stored in the parser.
     GENERIC, PUBLIC    :: get_positional     => ap_get_positional_sc, &
                                                 ap_get_positional_ve
@@ -372,5 +369,5 @@
                                                 ap_get_cv_ve, &
                                                 ap_get_sv_ve
-#endif       
+#endif
   END TYPE argparser
 
@@ -380,9 +377,9 @@
   ! -------------------------------
 
-  FUNCTION new_argparser(usg, dsc, epg, add_help, width, max_help_pos) RESULT(this) 
+  FUNCTION new_argparser(usg, dsc, epg, add_help, add_version, version_string,width, max_help_pos) RESULT(this)
     !! Initialize an argparser object.
-    !! 
+    !!
     !! The method initializes (properly) an [[argparse(module):argparser(type)]] object.
-    !! Even if all the arguments are optional, it is mandatory to **call** the method 
+    !! Even if all the arguments are optional, it is mandatory to **call** the method
     !! before using an argparser object.
     CHARACTER(len=*), INTENT(in), OPTIONAL :: usg
@@ -394,14 +391,20 @@
       !! An optional string with the epilog of the program's help
     LOGICAL, INTENT(in), OPTIONAL          :: add_help
-      !! An optional boolean flag with `.true.` to automatically set an option for program's help. 
+      !! An optional boolean flag with `.true.` to automatically set an option for program's help.
       !! Note that, the option flags `-h` and `--help` are no more available in that case.
+    LOGICAL, INTENT(in), OPTIONAL          :: add_version
+      !! An optional boolean flag with `.true.` to automatically set an option for program's help.
+      !! Note that, the option flags `-V` and `--version` are no more available in that case.
+    CHARACTER(len=*), INTENT(in), OPTIONAL :: version_string
+      !! An optional string with the text to display if the *version* option is found on the
+      !! command line. The text is displayed without any format.
     INTEGER, INTENT(in), OPTIONAL          :: width
       !! An optional integer with the maximum width the help text.
     INTEGER, INTENT(in), OPTIONAL          :: max_help_pos
-      !! An optional integer with the maximum position of the help string for each option of 
-      !! the program when help is requested. Note that this value is just an indicator. The 
-      !! helper computes the minimum position between this value and the maximum length of the 
+      !! An optional integer with the maximum position of the help string for each option of
+      !! the program when help is requested. Note that this value is just an indicator. The
+      !! helper computes the minimum position between this value and the maximum length of the
       !! options flags.
-    TYPE(argparser) :: this 
+    TYPE(argparser) :: this
       !! An initialized argparse object.
     INTEGER     :: zh
@@ -413,5 +416,5 @@
     IF (PRESENT(dsc)) THEN ; this%descr=dsc ; ELSE ; this%descr='' ; ENDIF
     IF (PRESENT(epg)) THEN ; this%eplg=epg  ; ELSE ; this%eplg=''  ; ENDIF
-    CALL fs_termsize(zh,this%width) 
+    CALL fs_termsize(zh,this%width)
     IF (PRESENT(width)) this%width = MAX(width,50)
     IF(PRESENT(max_help_pos)) this%mxhlpos = MAX(5,max_help_pos)
@@ -422,4 +425,11 @@
                     action=ap_help, help="Print this help and quit")
     ENDIF
+    IF (PRESENT(add_version)) THEN
+      IF (add_version) &
+        err = argparser_add_option(this,'version',sflag='-V',lflag='--version', &
+                    action=ap_version, help="Print the application version and quit")
+      this%vers = ''
+      if (PRESENT(version_string)) this%vers = TRIM(version_string)
+    ENDIF
     RETURN
   END FUNCTION new_argparser
@@ -432,5 +442,5 @@
     !! @note If **fccp** has not been built with support for finalization subroutine,
     !! it should be called whenever the argparser object is no more used.
-    TYPE(argparser), INTENT(inout) :: this 
+    TYPE(argparser), INTENT(inout) :: this
       !! An argparser object
     IF (ALLOCATED(this%args)) THEN
@@ -466,5 +476,5 @@
     !!
     !! The method initializes the entry for positional arguments in the parser.
-    !! Positional arguments are always seen by the parser as strings and the 
+    !! Positional arguments are always seen by the parser as strings and the
     !! default associated action is 'store'.
     OBJECT(argparser), INTENT(inout)                     :: this
@@ -475,5 +485,5 @@
       !! A vector of strings with the the displayed value name(s) of the positionals in the help command
     CHARACTER(len=*), INTENT(in), OPTIONAL               :: help
-      !! An optional string with a short description of the positional argument(s) 
+      !! An optional string with a short description of the positional argument(s)
     TYPE(error) :: err
       !! Error object with the first error encountered in the process.
@@ -481,6 +491,6 @@
     CHARACTER(len=:), ALLOCATABLE :: sf,lf,de
     err = noerror
-    IF (.NOT.this%init) THEN 
-      err = error("argparse: parser not initialized yet",-1) 
+    IF (.NOT.this%init) THEN
+      err = error("argparse: parser not initialized yet",-1)
       RETURN
     ENDIF
@@ -504,5 +514,5 @@
         RETURN
       ENDIF
-      this%have_posal = this%posals%nrec /= 0 
+      this%have_posal = this%posals%nrec /= 0
     ENDIF
     RETURN
@@ -514,7 +524,7 @@
     !! given as optional argument and fills the parser's arguments.
     !! @note
-    !! If `cmd_line` is provided it should not contains the name of the program or 
-    !! the parsing process will certainly failed: program name will be seen as the 
-    !! first positional argument and all tokens of the string will then be seen as 
+    !! If `cmd_line` is provided it should not contains the name of the program or
+    !! the parsing process will certainly failed: program name will be seen as the
+    !! first positional argument and all tokens of the string will then be seen as
     !! positional.
     OBJECT(argparser), INTENT(inout)       :: this
@@ -523,5 +533,5 @@
       !! An optional string to parse that substitute for the actual command-line.
     LOGICAL, INTENT(in), OPTIONAL          :: auto
-      !! An optional boolean flag with `.true.` to instruct the parser wether to perform 
+      !! An optional boolean flag with `.true.` to instruct the parser wether to perform
       !! automatic actions or not when error occur during parsing. If `auto` is enabled,
       !! then the parser dumps program's usage and stops the program on error.
@@ -530,6 +540,7 @@
     CHARACTER(len=:), ALLOCATABLE :: cline,z
     LOGICAL                       :: zauto
-    LOGICAL                       :: rhelp 
-    INTEGER                       :: l 
+    LOGICAL                       :: rhelp
+    LOGICAL                       :: rvers
+    INTEGER                       :: l
     TYPE(words)                   :: cmd_tokens
     err = noerror
@@ -537,10 +548,10 @@
       err = error("parser not initialized yet",-1) ; RETURN
     ENDIF
-    rhelp = .false.
+    rhelp = .false. ; rvers = .false.
     zauto = .false. ; IF (PRESENT(auto)) zauto = auto
     IF (PRESENT(cmd_line)) THEN
       ALLOCATE(cline,source=cmd_line)
     ELSE
-      CALL GET_COMMAND(length=l) 
+      CALL GET_COMMAND(length=l)
       ALLOCATE(CHARACTER(len=l) :: z) ; CALL GET_COMMAND(z)
       CALL GET_COMMAND_ARGUMENT(0,length=l)
@@ -557,5 +568,5 @@
         EXIT ! ... No :)
       ELSE
-        err = ap_split_cmd(this,cline,cmd_tokens,rhelp) 
+        err = ap_split_cmd(this,cline,cmd_tokens,rhelp)
         ! we only stops processing if :
         !   - the internal error (string length) is raised
@@ -565,11 +576,11 @@
       CALL words_reset(cmd_tokens) ! not mandatory... at least theoretically
       ! Parses the options
-      err = ap_parse_options(this,cmd_tokens,rhelp) 
+      err = ap_parse_options(this,cmd_tokens,rhelp,rvers)
       IF (err /= noerror) EXIT
-      ! exit loop if help is requested. Parser is not completely filled but we
-      ! expect someone to use the help action..
-      IF (rhelp) EXIT
+      ! exit loop if help or version is requested. Parser is not completely filled but we
+      ! expect someone to use the help or version actions...
+      IF (rhelp.OR.rvers) EXIT
       ! Parses positionals
-      err = ap_parse_positionals(this,cmd_tokens) 
+      err = ap_parse_positionals(this,cmd_tokens)
       EXIT ! A one iterated loop :)
     ENDDO
@@ -581,8 +592,18 @@
     IF (zauto) THEN
       IF (rhelp) CALL argparser_help(this)
+      IF (rvers) CALL argparser_version(this)
       IF (err /= 0) CALL argparser_throw_error(this,err,2)
     ENDIF
-    RETURN 
+    RETURN
   END FUNCTION argparser_parse
+
+  SUBROUTINE argparser_version(this)
+    !! Print version string and exit program
+    OBJECT(argparser), INTENT(inout) :: this
+      !! An argparser object reference
+    WRITE(stdout,'(a)') TRIM(this%vers)
+    CALL argparser_clear(this)
+    CALL EXIT(0)
+  END SUBROUTINE argparser_version
 
   SUBROUTINE argparser_help(this)
@@ -606,5 +627,5 @@
     !!
     !! The method performs the following actions:
-    !!  
+    !!
     !! - Print the usage command of the program
     !! - Dump the provided @p error message
@@ -614,5 +635,5 @@
     !!
     !! The error message is always printed in standard error output.
-    !! @note 
+    !! @note
     !! If errors::error::id is 0 the method does nothing.
     OBJECT(argparser), INTENT(inout) :: this
@@ -638,5 +659,5 @@
   FUNCTION argparser_found(this,argname) RESULT(found)
     !! Check wether an argument has been found in the command-line.
-    !! @note 
+    !! @note
     !! Keep in mind that arguments in the parser always have a default
     !! value. This method is not intended to check if an argument has a value but
@@ -663,5 +684,5 @@
     CHARACTER(len=*), INTENT(in)  :: argname
       !! Name of the argument to check.
-    INTEGER :: num 
+    INTEGER :: num
       !! The number of actual values stored in the argument
     INTEGER  :: idx
@@ -693,9 +714,9 @@
     INTEGER :: ret
       !! The number of actual positionals arguments
-    ret = 0 
+    ret = 0
     IF (this%have_posal) THEN
       ret = words_length(this%posals%values)
     ENDIF
-  END FUNCTION argparser_get_num_positional 
+  END FUNCTION argparser_get_num_positional
 
   ! argparser private methods
@@ -703,5 +724,5 @@
 
   FUNCTION ap_check_state(this) RESULT(err)
-    !! Check current parser state 
+    !! Check current parser state
     !! The method returns an error based on the current parser's state:
     !! - Parser is ready (0)
@@ -712,5 +733,5 @@
       !! An argparser object reference
     TYPE(error) :: err
-      !! Error object with the *status* of the parser 
+      !! Error object with the *status* of the parser
     err = noerror
     IF (this%parsed == -1) THEN
@@ -719,5 +740,5 @@
       err = error("argparse: command-line parsing failed",-20)
     ELSE IF (.NOT.this%init) THEN
-      err = error("argparse: parser not initialized yet",-1) 
+      err = error("argparse: parser not initialized yet",-1)
     ENDIF
     RETURN
@@ -732,5 +753,5 @@
     INTEGER                               :: i
     TYPE(argc), ALLOCATABLE, DIMENSION(:) :: tmp
-    TYPE(error) :: err 
+    TYPE(error) :: err
     IF (.NOT.this%init)  THEN
       err = error("parser not initialized yet",-1) ; RETURN
@@ -739,6 +760,6 @@
     IF (this%nargs == 0) THEN
       ALLOCATE(this%args(1))
-      this%args(1) = arg 
-      this%nargs = 1 
+      this%args(1) = arg
+      this%nargs = 1
       RETURN
     ENDIF
@@ -749,6 +770,6 @@
     ALLOCATE(tmp(this%nargs))
     DO i=1,this%nargs ; tmp(i) = this%args(i) ; ENDDO
-    CALL clear_argc(this%args) 
-    DEALLOCATE(this%args) 
+    CALL clear_argc(this%args)
+    DEALLOCATE(this%args)
     this%nargs = this%nargs+1 ; ALLOCATE(this%args(this%nargs))
     DO i=1,this%nargs-1 ; this%args(i) = tmp(i) ; ENDDO
@@ -782,5 +803,5 @@
     ! empty parser
     IF (this%nargs == 0) RETURN
-    DO i=1, this%nargs 
+    DO i=1, this%nargs
       IF ((nn /= 0 .AND. TRIM(this%args(i)%name)  == TRIM(lna)) .OR. &
           (ns /= 0 .AND. TRIM(this%args(i)%sflag) == TRIM(lsf)) .OR. &
@@ -796,7 +817,7 @@
     !! Add an argument to the parser (interface #1)
     !!
-    !! The function defines a new argument based on input parameters, checks it and finally sets it 
+    !! The function defines a new argument based on input parameters, checks it and finally sets it
     !! in the parser. Both **short and long options flags** are mandatory input arguments of the function.
-    !! 
+    !!
     !!  `type` value should be one of the following module constants (which are aliases from [[string_op(module)]]):
     !!  - ap_string ([[string_op(module):st_string(variable)]])
@@ -805,5 +826,5 @@
     !!  - ap_integer ([[string_op(module):st_integer(variable)]])
     !!  - ap_real ([[string_op(module):st_real(variable)]])
-    !! 
+    !!
     !!  `action` value should be one of the following module constants:
     !!  - [[argparse(module):ap_store(variable)]]
@@ -830,11 +851,11 @@
       !! A string (3 characters minimum) with the long option flag of the argument
     INTEGER, INTENT(in), OPTIONAL                        :: type
-      !! An integer with the type of the argument 
+      !! An integer with the type of the argument
     INTEGER, INTENT(in), OPTIONAL                        :: action
-      !! An integer with the action of the argument 
+      !! An integer with the action of the argument
     CHARACTER(len=*), INTENT(in), OPTIONAL               :: default
       !! A string with the default value of the argument if not provided in the CLI
     CHARACTER(len=*), INTENT(in), OPTIONAL               :: nrec
-      !! A string with the expected number of specified values for the argument in the CLI. 
+      !! A string with the expected number of specified values for the argument in the CLI.
     CHARACTER(len=*), INTENT(in), OPTIONAL               :: help
       !! A string with a short description of the argument
@@ -853,5 +874,5 @@
     de =''        ; IF (PRESENT(default)) de = TRIM(default)
     IF (.NOT.this%init)  THEN
-      err = error("argparse: parser not initialized yet",-1) 
+      err = error("argparse: parser not initialized yet",-1)
       RETURN
     ENDIF
@@ -876,9 +897,9 @@
     !! Add an argument to the parser (interface #2)
     !!
-    !! The function is a wrapper to ap_add_option_1. In this version, 
+    !! The function is a wrapper to ap_add_option_1. In this version,
     !! only one option flag is required. The method only checks for the (trimmed) length of **flag** in
-    !! order to choose wether it is a **short** or **long** option flag. Then the function simply calls 
+    !! order to choose wether it is a **short** or **long** option flag. Then the function simply calls
     !! ap_add_option_1 to set the argument.
-    !! 
+    !!
     !! Other dummy arguments have the same meaning as in ap_add_option_1.
     OBJECT(argparser), INTENT(inout)                     :: this
@@ -891,9 +912,9 @@
       !! A string with the type of the argument
     INTEGER, INTENT(in), OPTIONAL                        :: action
-      !! A string with the action of the argument 
+      !! A string with the action of the argument
     CHARACTER(len=*), INTENT(in), OPTIONAL               :: default
       !! A string with the default value of the argument if not provided in the CLI
     CHARACTER(len=*), INTENT(in), OPTIONAL               :: nrec
-      !! A string with the expected number of specified values for the argument in the CLI. 
+      !! A string with the expected number of specified values for the argument in the CLI.
     CHARACTER(len=*), INTENT(in), OPTIONAL               :: help
       !! A string with a short description of the argument
@@ -956,7 +977,7 @@
   END FUNCTION ap_check_in_parser
 
-  FUNCTION ap_parse_options(this,cmd,help_req) RESULT(err)
+  FUNCTION ap_parse_options(this,cmd,help_req,vers_req) RESULT(err)
     !! Parse options of the internal command line
-    !! This (internal) function manages the parsing of the command line options. 
+    !! This (internal) function manages the parsing of the command line options.
     OBJECT(argparser), INTENT(inout), TARGET :: this
       !! An argparser object reference
@@ -965,4 +986,6 @@
     LOGICAL, INTENT(out)                     :: help_req
       !! An output logical flag with `.true.` if help option has been found, `.false.` otherwise
+    LOGICAL, INTENT(out)                     :: vers_req
+      !! An output logical flag with `.true.` if version option has been found, `.false.` otherwise
     TYPE(error) :: err
       !! Error object with the first error encountered in the process
@@ -976,13 +999,19 @@
       ! get current element
       elt = words_current(cmd)
-      ! check element kind: is it an option flag (-1/0)or a value (1)?
+      ! check element kind: is it an option flag (-1/0) or a value (1)?
       ic = ap_check_string(this,elt,arg_idx)
       IF (ic <= 0) THEN
         IF (arg_idx /= -1) THEN
           err = ap_fill_argument(this,cmd,this%args(arg_idx))
-          IF (err == 0 .AND. this%args(arg_idx)%paction == ap_help) THEN
-            this%parsed = 1
-            err = argparser_get_value(this,'help',help_req)
-            EXIT
+          IF (err == 0) THEN
+            IF (this%args(arg_idx)%paction == ap_help) THEN
+              this%parsed = 1
+              err = argparser_get_value(this,'help',help_req)
+              EXIT
+            ELSE IF (this%args(arg_idx)%paction == ap_version) THEN
+              this%parsed = 1
+              err = argparser_get_value(this,'version',vers_req)
+              EXIT
+            ENDIF
           ENDIF
           IF (err /= 0) EXIT
@@ -998,5 +1027,5 @@
       ! iterates to next value
       CALL words_next(cmd)
-    ENDDO 
+    ENDDO
 
     ! Do we need to check for error here ?
